REM ITA2RST 0.9
REM Alter PLAYERx.RST files to show the right scores
REM Written using MS QBasic 4.5 & PRO.LIB

OPTION BASE 1
DEFSTR A
DEFINT I
DEFLNG L
DEFDBL D
DEFSNG S

DECLARE FUNCTION Exist% (aNomeDB)
DECLARE FUNCTION aSentiero (aPathDB)
DECLARE SUB Stampalog (aTemp)

REM we must have a safe landplace ;)
ON ERROR GOTO Generico:

DIM SHARED lBigTotal
DIM SHARED lTotals(11)
DIM SHARED sTotPerc(11)
DIM SHARED iTotPerc(11)
DIM SHARED iPosRace(11)
DIM SHARED lSortedTotals(11)
DIM SHARED iSortedRace(11)
DIM SHARED aTERR(99)

REM score counters
TYPE RSTxRCD
   iRSTxPlanet AS INTEGER
   iRSTxShip AS INTEGER
   iRSTxFreighter AS INTEGER
   iRSTxStarB AS INTEGER
END TYPE

DIM SHARED uScoreRSTx AS RSTxRCD

REM $INCLUDE: 'C:\planets\source\DBdefs.180'

DIM SHARED uConfig AS ConfigRCD
DIM SHARED uCnfPlanet AS CnfPlanetRCD
DIM SHARED uCnfScore AS CnfScoreRCD
DIM SHARED aPathDB
DIM SHARED aCR

CONST aRel = "ITA2RST 0.9"
CONST aAuthor = "Paolo Fiore (Genoa, Italy)"
CONST aPlayerDB = "PLAYER"
CONST aPlayerExtDB = ".RST"
CONST aLogDB = "ITA2RST.LOG"
CONST aConfigDB = "ITASETUP.DAT"

REM --------------------- well, enjoy yourself -------------------

REM $INCLUDE: 'C:\planets\source\err_list.bas'

REM preparing the path
aPathDB = aSentiero(COMMAND$)

aNomeDB = aPathDB + aConfigDB
IF NOT Exist%(aNomeDB) THEN GOTO fine:
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
GET #1, , uConfig
IF uConfig.aChgRST = "N" THEN GOTO fine:
CLOSE #1

REM log file opened until program finish as #9
REM aNomeDB = aPathDB + aScoreDB
REM IF Exist%(aNomeDB) THEN KILL aNomeDB
aNomeDB = aPathDB + aLogDB
OPEN aNomeDB FOR OUTPUT AS #9

Stampalog aRel
Stampalog DATE$ + " " + TIME$
Stampalog SPACE$(1)

REM configuration parameters
aNomeDB = aPathDB + aConfigDB
Stampalog " Loading " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
GET #1, , uConfig
iConfigPos = 1 + LOC(1) + (LEN(uCnfPlanet) * 500)
SEEK #1, iConfigPos
FOR iInd = 1 TO 11
    GET #1, , uCnfScore
    lTotals(iInd) = uCnfScore.lNewScore
    lBigTotal = lBigTotal + lTotals(iInd)
NEXT
CLOSE #1

FOR iInd = 1 TO 11
   iSortedRace(iInd) = iInd
NEXT
FOR iInd = 1 TO 11
    lSortedTotals(iInd) = lTotals(iInd)
NEXT

DO
   aTemp = "N"
   FOR iInd = 1 TO 10
       IF lSortedTotals(iInd) < lSortedTotals(iInd + 1) THEN
          aTemp = "S"
          lTempTotal = lSortedTotals(iInd)
          iTempRace = iSortedRace(iInd)
          lSortedTotals(iInd) = lSortedTotals(iInd + 1)
          iSortedRace(iInd) = iSortedRace(iInd + 1)
          lSortedTotals(iInd + 1) = lTempTotal
          iSortedRace(iInd + 1) = iTempRace
       END IF
   NEXT
LOOP WHILE aTemp = "S"

FOR iRace = 1 TO 11
    FOR iInd = 1 TO 11
        IF iSortedRace(iInd) = iRace THEN iPosRace(iRace) = iInd
    NEXT
NEXT

REM percentage
FOR iInd = 1 TO 11
   IF lBigTotal > 0 AND lTotals(iInd) > 0 THEN
      sTotPerc(iInd) = (lTotals(iInd) / lBigTotal) * 200
      iTotPerc(iInd) = sTotPerc(iInd)
   END IF
NEXT

REM Altering PLAYERx.RST
FOR iRace = 1 TO 11
   aNomeDB = aPathDB + aPlayerDB + LTRIM$(STR$(iRace)) + aPlayerExtDB
   IF Exist%(aNomeDB) THEN
      Stampalog " Altering " + aNomeDB
      OPEN aNomeDB FOR BINARY ACCESS READ WRITE AS #1
      SEEK #1, 24 + 1
      GET #1, , lPointer
      SEEK #1, lPointer + 18
      FOR iInd = 1 TO 11
         uScoreRSTx.iRSTxPlanet = 0
         uScoreRSTx.iRSTxStarB = 0
         uScoreRSTx.iRSTxShip = iTotPerc(iInd) \ 10
         REM uScoreRSTx.iRSTxFreighter = iPosRace(iInd)
         uScoreRSTx.iRSTxFreighter = iTotPerc(iInd) - (uScoreRSTx.iRSTxShip * 10)
         PUT #1, , uScoreRSTx
      NEXT
      CLOSE #1
   END IF
NEXT

REM Ok, shutting down
aTemp = "Free Memory:" + STR$(FRE(-1))
Stampalog aTemp
Stampalog "The ITA2RST - Ending!"
CLOSE #9
REM I have to jump error routines
GOTO fine:

REM --------------------------------------------------------------
ErrOK:
REM All OK! ;)) I need to go ahead (e.g. new file and so on)
iErrResume = ERR
RESUME NEXT

REM --------------------------------------------------------------
Generico:
REM Here is a real bloody error I never considered.
Stampalog "*** Unrecoverable Error: " + STR$(ERR)
Stampalog "      " + aTERR(ERR)

fine:
END

FUNCTION aSentiero (aPathDB)

aPathDB = RTRIM$(aPathDB)

REM if needed I insert final slash
IF RIGHT$(aPathDB, 1) <> "\" THEN
   aPathDB = aPathDB + "\"
END IF

aSentiero = aPathDB

END FUNCTION

SUB Stampalog (aTemp)

PRINT aTemp
PRINT #9, aTemp
REM aTemp = " "

END SUB

