REM ITASCORE 2.0RC4
REM This program has been written for the VGA Planets community
REM 'just for fun' and it is provided 'as is' with no guarantee at all
REM   [Written with MS QBasic 4.5 & PRO.LIB]

REM Simply, this is the ultimate scoring program; 100% configurable!
REM The leading edge for getting the most equilibrate game end
REM Certainly the best of breed... worldwide! ;)
REM Ask for anything at info@paolofiore.it

OPTION BASE 1
DEFSTR A
DEFINT I
DEFLNG L
DEFDBL D
DEFSNG S

REM $INCLUDE: 'C:\planets\source\DBDefs.180'

DIM SHARED uConfig AS ConfigRCD
DIM SHARED uCnfPlanet AS CnfPlanetRCD
DIM SHARED uCnfScore AS CnfScoreRCD
DIM SHARED uNextTurn AS NextTurnRCD
DIM SHARED uPlanet AS PlanetRCD
DIM SHARED uXYPlan AS XYPlanRCD
DIM SHARED uStarbase AS StarbaseRCD
DIM SHARED uShip AS ShipRCD
DIM SHARED uSHShipXY AS ShipXYRCD
DIM SHARED uEngine AS EngineRCD
DIM SHARED uHull AS HullRCD
DIM SHARED uBeam AS BeamRCD
DIM SHARED uLauncher AS LauncherRCD
DIM SHARED uMine AS MineRCD
DIM SHARED uMessPnt AS MessPntRCD

DIM SHARED aFKeepSB
DIM SHARED uPlanetArrey(500) AS CnfPlanetRCD

DIM SHARED aTERR(99)
DIM SHARED iMineFigure(10)
DIM SHARED aRaces(11)
DIM SHARED lMsgPlnBonus(11)
'HomeWorlds
DIM SHARED iHWPlnID(11)
DIM SHARED iHWPlnX(11)
DIM SHARED iHWPlnY(11)

REM The final counters for each race
DIM SHARED lShips(11)
DIM SHARED lPlanets(11)
DIM SHARED lResources(11)
DIM SHARED lDefences(11)
DIM SHARED lDistances(11)
DIM SHARED lSBTechL(11)
DIM SHARED lSBDefences(11)
DIM SHARED lKeepSB(11)
DIM SHARED lOldKeepSB(11)
DIM SHARED lFighters(11)
DIM SHARED lTons(11)
DIM SHARED lMines(11)
DIM SHARED lTorpedos(11)

DIM SHARED lTotals(11)
DIM SHARED sTotPerc(11)
DIM SHARED lBigTotal

REM SparePart tables - cost, ore, tech
TYPE EngineTAB
   iCost AS INTEGER
   iOre AS INTEGER
   iTech AS INTEGER
END TYPE

TYPE HullTAB
   iCost AS INTEGER
   iOre AS INTEGER
   iTech AS INTEGER
   iEngNum AS INTEGER
   iMass AS INTEGER
END TYPE

TYPE BeamTAB
   iCost AS INTEGER
   iOre AS INTEGER
   iTech AS INTEGER
END TYPE

TYPE LauncherTAB
   iCost AS INTEGER
   iOre AS INTEGER
   iTech AS INTEGER
   iTorpCost AS INTEGER
END TYPE

DIM SHARED TEngine(9) AS EngineTAB
DIM SHARED THull(105) AS HullTAB
DIM SHARED TBeam(10) AS BeamTAB
DIM SHARED TLauncher(10) AS LauncherTAB

DIM SHARED aPathDB
DIM SHARED aCR
DIM SHARED iTurnNum

CONST aRel = "ITAScore 2.0 RC4"
CONST aAuthor = "Paolo Fiore (Genoa, Italy)"
CONST aGENDB = "GEN.HST"
CONST aAScoreDB = "ASCORE.DAT"
CONST aRaceDB = "RACE.NM"
CONST aPlanetDB = "PDATA.HST"
CONST aXYPlanDB = "XYPLAN.HST"
CONST aStarbaseDB = "BDATA.HST"
CONST aShipDB = "SHIP.HST"
CONST aSHCoordDB = "SHIPXY.HST"
CONST aMineDB = "MINES.HST"
CONST aTonDB = "TONS.HST"
CONST aEngineDB = "ENGSPEC.DAT"
CONST aHullDB = "HULLSPEC.DAT"
CONST aBeamDB = "BEAMSPEC.DAT"
CONST aLauncherDB = "TORPSPEC.DAT"
CONST aMsgDB = "MESS.EXT"
CONST aMsgPntDB = "MESSPNT.EXT"
CONST aNextTurnDB = "NEXTTURN.HST"

REM ITASCore files
CONST aLogDB = "ITASCORE.LOG"
CONST aScoreDB = "ITASCORE.TXT"
CONST aConfigDB = "ITASETUP.DAT"

DECLARE FUNCTION Exist% (aNomeDB)
DECLARE FUNCTION aCripta (aMessaggio)
DECLARE FUNCTION aDecimali (sPerc)
DECLARE FUNCTION aFormatta (lValore)
DECLARE FUNCTION iTurno ()
DECLARE FUNCTION aSentiero (aPathDB)
DECLARE FUNCTION aComputa (aOperazione)
DECLARE SUB Stampalog (aTemp)
DECLARE SUB PublicMsg (aMessaggio)
DECLARE SUB ConfigMsg (aMessaggio)
DECLARE SUB ComuneMsg (aMessaggio, iInd)
DECLARE SUB RaceMsg (aMessaggio, iInd)
DECLARE SUB KeepSBMsg (aMessaggio, iInd)
DECLARE SUB PlnBonusMsg (aMessaggio, iInd)
'DECLARE SUB ReplaceChar (aString, aOldChar, aNewChar)

DECLARE SUB LogScore ()

REM any "input" archive has its own reading procedure
DECLARE SUB ApplyMath ()
DECLARE SUB BasicPartDB ()
DECLARE SUB CfgPlnDB ()
DECLARE SUB PlanetDB (lResources(), lPlanets())
DECLARE SUB XYPlanDB (lDistances())
DECLARE SUB XYComputeZ (lWZ)
DECLARE SUB XYHWorldLY (lWZ)
DECLARE SUB XYCentrumLY (lWZ)
DECLARE SUB StarbaseDB (lSBDefences, lSBTechL, lFighters())
DECLARE SUB KeepSB (iRace, iId)
DECLARE SUB ShipDB (lShips(), lFighters(), lTorpedos())
DECLARE SUB MineDB (lMines())
DECLARE SUB TonDB (lTons())

REM we must have a safe landplace ;)
ON ERROR GOTO Generico:

aCR = CHR$(13)

REM $INCLUDE: 'C:\planets\source\err_list.bas'

REM units for one torp each techL
iMineFigure(1) = 1
iMineFigure(2) = 4
iMineFigure(3) = 9
iMineFigure(4) = 16
iMineFigure(5) = 25
iMineFigure(6) = 36
iMineFigure(7) = 49
iMineFigure(8) = 64
iMineFigure(9) = 81
iMineFigure(10) = 100

REM Progessive Costs for each SBase TechL (unused!)
REM iBaseTechL(1) = 1
REM iBaseTechL(2) = 100
REM iBaseTechL(3) = 300
REM iBaseTechL(4) = 600
REM iBaseTechL(5) = 1000
REM iBaseTechL(6) = 1500
REM iBaseTechL(7) = 2100
REM iBaseTechL(8) = 2800
REM iBaseTechL(9) = 3600
REM iBaseTechL(10) = 4500

REM --------------------- well, enjoy yourself -------------------
REM Keep in mind the below notes:
REM - dont get confused by SUB parameters... there's a wide use of the SHARED!
REM - every sub is started when the archive is already opened as #1
REM   and the first record is already present in the I/O buffer

REM preparing the path
aPathDB = aSentiero(COMMAND$)

REM log file opened until program finish as #9
REM aNomeDB = aPathDB + aScoreDB
REM IF Exist%(aNomeDB) THEN KILL aNomeDB
aNomeDB = aPathDB + aLogDB
OPEN aNomeDB FOR OUTPUT AS #9

Stampalog aRel
Stampalog DATE$ + " " + TIME$
Stampalog SPACE$(1)

REM Next turn
iTurnNum = iTurno

REM configuration parameters (there's just one config file)
aNomeDB = aPathDB + aConfigDB
IF NOT Exist%(aNomeDB) THEN GOTO fine:
Stampalog " Loading " + aNomeDB
Stampalog "    Acquiring switches"
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
GET #1, , uConfig

Stampalog "    Acquiring planet bonuses and existing Starbases"
FOR iInd = 1 TO 500
   GET #1, , uCnfPlanet
  
   uPlanetArrey(iInd).iBonus = uCnfPlanet.iBonus
   uPlanetArrey(iInd).iRace = uCnfPlanet.iRace
   uPlanetArrey(iInd).iTurns = uCnfPlanet.iTurns
   uPlanetArrey(iInd).aBase = uCnfPlanet.aBase
   IF uCnfPlanet.aBase = "H" THEN iHWPlnID(uCnfPlanet.iRace) = iInd
NEXT

REM Counters (lOldScore & lNewScore) are simply useless and not acquired
Stampalog "    Acquiring old bonuses"
FOR iInd = 1 TO 11
   GET #1, , uCnfScore
   lOldKeepSB(iInd) = uCnfScore.lTotBonus
NEXT

CLOSE #1


REM Fixed files (engine, beam etc tables)
Stampalog " Loading Fixed Data"
BasicPartDB

REM Race names
aNomeDB = aPathDB + aRaceDB
Stampalog " Digesting " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
SEEK #1, 330 + 1 'jump long names
FOR iInd = 1 TO 11
   aRaces(iInd) = SPACE$(20)
   GET #1, , aRaces(iInd)
NEXT
CLOSE #1

REM Clear the name for non playing races
aNomeDB = aPathDB + aGENDB
Stampalog " Digesting " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
SEEK #1, 46 + 1 'jump a filler
FOR iInd = 1 TO 11
   GET #1, , iTemp
   IF iTemp = 0 THEN aRaces(iInd) = ""
NEXT
CLOSE #1

REM planets
aNomeDB = aPathDB + aPlanetDB
Stampalog " Digesting " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
REM there's a useless record; I throw it away
GET #1, , iDummy
GET #1, , uPlanet
PlanetDB lResources(), lPlanets()
CLOSE #1

REM HomeWorlds coords
aNomeDB = aPathDB + aXYPlanDB
Stampalog " Getting HW coords " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
FOR iInd = 1 TO 500
   GET #1, , uXYPlan
   IF uXYPlan.iRace > 0 THEN
      IF iInd = iHWPlnID(uXYPlan.iRace) THEN
         iHWPlnX(uXYPlan.iRace) = uXYPlan.iX
         iHWPlnY(uXYPlan.iRace) = uXYPlan.iY
      END IF
   END IF
NEXT
CLOSE #1

REM planets coords
aNomeDB = aPathDB + aXYPlanDB
Stampalog " Digesting " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
GET #1, , uXYPlan
XYPlanDB lDistances()
CLOSE #1

REM Starbases
aNomeDB = aPathDB + aStarbaseDB
Stampalog " Digesting " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
REM there's a useless record; I throw it away
GET #1, , iDummy
GET #1, , uStarbase
StarbaseDB lSBDefences, lSBTechL, lFighters()
CLOSE #1

REM ships
aNomeDB = aPathDB + aShipDB
Stampalog " Digesting " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
REM there's a useless record; I throw it away
GET #1, , iDummy
GET #1, , uShip
ShipDB lShips(), lFighters(), lTorpedos()
CLOSE #1

REM Minefields
aNomeDB = aPathDB + aMineDB
Stampalog " Digesting " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
GET #1, , uMine
MineDB lMines()
CLOSE #1

REM Tons
aNomeDB = aPathDB + aTonDB
Stampalog " Digesting " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
TonDB lTons()
CLOSE #1

Stampalog " And now the Math..."

lBigTotal = 0
FOR iInd = 1 TO 11
   lTotals(iInd) = lPlanets(iInd)
   IF uConfig.aMineFields = "Y" THEN lTotals(iInd) = lTotals(iInd) + lMines(iInd)
   IF uConfig.aPlnResources = "Y" THEN lTotals(iInd) = lTotals(iInd) + lResources(iInd)
   IF uConfig.aPlnDefences = "Y" THEN lTotals(iInd) = lTotals(iInd) + lDefences(iInd)
   IF uConfig.aShips = "Y" THEN lTotals(iInd) = lTotals(iInd) + lShips(iInd)
   IF uConfig.aTons = "Y" THEN lTotals(iInd) = lTotals(iInd) + lTons(iInd)
   IF uConfig.aStarbases = "Y" THEN lTotals(iInd) = lTotals(iInd) + lSBDefences(iInd)
   IF uConfig.aStarbases = "Y" THEN lTotals(iInd) = lTotals(iInd) + lSBTechL(iInd)
   IF uConfig.aKeepSBs = "Y" THEN lTotals(iInd) = lTotals(iInd) + lOldKeepSB(iInd) + lKeepSB(iInd)
   IF uConfig.aTorpedos = "Y" THEN lTotals(iInd) = lTotals(iInd) + lTorpedos(iInd)
   IF uConfig.aFighters = "Y" THEN lTotals(iInd) = lTotals(iInd) + lFighters(iInd)
   IF uConfig.aDistanceType <> "N" THEN lTotals(iInd) = lTotals(iInd) + lDistances(iInd)
   lBigTotal = lBigTotal + lTotals(iInd)
NEXT iInd
FOR iInd = 1 TO 11
   IF lBigTotal > 0 AND lTotals(iInd) > 0 THEN sTotPerc(iInd) = lTotals(iInd) / lBigTotal
NEXT


REM Some data is going to be written onto the setup file
aNomeDB = aPathDB + aConfigDB
Stampalog " Archiving the score and StarBases: " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ WRITE AS #1

REM Positioning
REM I prefer not to use the seek to better allow layout modifications...
iConfigPos = 1 + LEN(uConfig)
FOR iInd = 1 TO 500
   uCnfPlanet.iBonus = uPlanetArrey(iInd).iBonus
   uCnfPlanet.iRace = uPlanetArrey(iInd).iRace
   uCnfPlanet.iTurns = uPlanetArrey(iInd).iTurns
   uCnfPlanet.aBase = uPlanetArrey(iInd).aBase
   PUT #1, iConfigPos, uCnfPlanet
   iConfigPos = LOC(1) + 1
NEXT

REM The score is going to be written onto the setup file
REM Again I'm not gonna use the seek to better allow layout modifications...
REM Positioning
iConfigPos = 1 + LEN(uConfig) + (500 * LEN(uCnfPlanet))
'SEEK #1, iConfigPos
FOR iInd = 1 TO 11
   'iConfigPos = LOC(1) + 1
   GET #1, iConfigPos, uCnfScore
   uCnfScore.lTotBonus = lOldKeepSB(iInd) + lKeepSB(iInd)
   uCnfScore.lOldScore = uCnfScore.lNewScore
   uCnfScore.lNewScore = lTotals(iInd)
   PUT #1, iConfigPos, uCnfScore
   iConfigPos = LOC(1) + 1
NEXT

CLOSE #1

REM Ok now I'm gonna write the ascore file
IF uConfig.aAScore = "Y" THEN
   aNomeDB = aPathDB + aAScoreDB
   Stampalog " Writing AutoScore: " + aNomeDB
   OPEN aNomeDB FOR BINARY ACCESS WRITE AS #1
   SEEK #1, 1
   FOR iInd = 1 TO 11
      dAScore = lTotals(iInd)
      PUT #1, , dAScore
   NEXT
   FOR iInd = 1 TO 11
      PUT #1, , sTotPerc(iInd)
   NEXT
   CLOSE #1
END IF

REM I'm gonna sort the scoring table; from now on the position won't be the race!
REM bubble loop... (ok ok I know, I know, not the best!)
DO
   aTemp = "N"
   FOR iInd = 1 TO 10
       IF lTotals(iInd) < lTotals(iInd + 1) THEN
          aTemp = "S"
          lTempTotal = lTotals(iInd)
          sTempPerc = sTotPerc(iInd)
          aTempRace = aRaces(iInd)
          lTotals(iInd) = lTotals(iInd + 1)
          sTotPerc(iInd) = sTotPerc(iInd + 1)
          aRaces(iInd) = aRaces(iInd + 1)
          lTotals(iInd + 1) = lTempTotal
          sTotPerc(iInd + 1) = sTempPerc
          aRaces(iInd + 1) = aTempRace
       END IF
   NEXT
LOOP WHILE aTemp = "S"

aNomeDB = aPathDB + aScoreDB
Stampalog " Writing the text score: " + aNomeDB
OPEN aNomeDB FOR OUTPUT AS #1
LogScore
CLOSE #1

Stampalog " Processing msgs onto: " + aPathDB + aMsgPntDB

Stampalog "    'Config' message"
ConfigMsg aMessaggio
aMessaggio = aCripta(aMessaggio)
FOR iInd = 1 TO 11
   ComuneMsg aMessaggio, iInd
NEXT iInd

IF uConfig.aMsgUsers = "Y" THEN
   Stampalog "    'Public' message"
   PublicMsg aMessaggio
   aMessaggio = aCripta(aMessaggio)
   FOR iInd = 1 TO 11
      ComuneMsg aMessaggio, iInd
   NEXT iInd

   Stampalog "    'Race' messages"
   FOR iInd = 1 TO 11
       RaceMsg aMessaggio, iInd
       aMessaggio = aCripta(aMessaggio)
       ComuneMsg aMessaggio, iInd
   NEXT iInd
END IF


Stampalog "    'Special' messages"
FOR iInd = 1 TO 11
    IF lMsgPlnBonus(iInd) > 0 THEN
       PlnBonusMsg aMessaggio, iInd
       aMessaggio = aCripta(aMessaggio)
       ComuneMsg aMessaggio, iInd
    END IF
    IF uConfig.aKeepSBs = "Y" AND lKeepSB(iInd) > 0 THEN
       KeepSBMsg aMessaggio, iInd
       aMessaggio = aCripta(aMessaggio)
       ComuneMsg aMessaggio, iInd
    END IF
NEXT iInd


REM Ok, shutting down
Stampalog SPACE$(1)
aTemp = "Free Memory:" + STR$(FRE(-1))
Stampalog aTemp
Stampalog "The Ultimate Scoring Routine - Ending!"
CLOSE #9
REM I have to jump error routines
GOTO fine:

REM --------------------------------------------------------------
ErrOK:
REM All OK! ;)) I need to go ahead (e.g. new file and so on)
iErrResume = ERR
RESUME NEXT

REM --------------------------------------------------------------
Generico:
REM Here is a real bloody error I never considered.
REM Should be I'm not as good as I thought? ;))))
Stampalog "*** Unrecoverable Error: " + STR$(ERR)
Stampalog "      " + aTERR(ERR)

fine:
END

REM time to rock
REM aCheat = aPathDB + "LEECHx.DAT"
REM IF Exist%(aCheat) THEN KILL aCheat
REM OPEN aCheat FOR BINARY ACCESS WRITE AS #2
REM PUT #2, , "something"
REM CLOSE #2
REM time to rock

FUNCTION aComputa (aStringa)

aComputa = aStringa

REM IF aStringa = "*" THEN aComputa = "multiplied by"
REM IF aStringa = "/" THEN aComputa = "divided by"
REM IF aStringa = "+" THEN aComputa = "added of"
REM IF aStringa = "-" THEN aComputa = "subtracted by"
REM IF aStringa = "%" THEN aComputa = "percentage of"


END FUNCTION

FUNCTION aCripta (aMessaggio)
REM security ;) simply add 13 to ASCII code.

FOR iInd = 1 TO LEN(aMessaggio)
    aTemp = CHR$(ASC(MID$(aMessaggio, iInd, 1)) + 13)
    MID$(aMessaggio, iInd, 1) = aTemp
NEXT iInd

aCripta = aMessaggio

END FUNCTION

FUNCTION aDecimali (sPerc)

aTemp = LTRIM$(STR$(sPerc))

FOR iInd = 1 TO LEN(aTemp)
    IF MID$(aTemp, iInd, 1) = "." THEN EXIT FOR
NEXT

aTemp1 = SPACE$(4)
SELECT CASE iInd
   CASE 1
      MID$(aTemp1, 3, 4) = MID$(aTemp, 1, 2)
   CASE 2
      MID$(aTemp1, 2, 3) = MID$(aTemp, 1, 3)
   CASE ELSE
      aTemp1 = MID$(aTemp, 1, 4)
END SELECT

IF MID$(aTemp1, 4, 1) <> " " THEN
   IF MID$(aTemp1, 1, 3) = "  ." THEN MID$(aTemp1, 2, 1) = "0"
END IF
IF aTemp1 = " 0  " THEN aTemp1 = " 0.0"

aDecimali = aTemp1

END FUNCTION

REM doesn't manage decimals
FUNCTION aFormatta (lValore)

REM the most right group will be the 1
DIM aTriple(7)

aSrc = LTRIM$(STR$(INT(lValore)))
iStop = LEN(aSrc) \ 3

REM the loop manages just the whole "triples"
FOR iInd = 1 TO iStop
    iStart = LEN(aSrc) + 1 - (iInd * 3)
    aTriple(iInd) = MID$(aSrc, iStart, 3)
NEXT

REM the remaining non-complete "triple"
iRemaind = LEN(aSrc) MOD 3
IF iRemaind <> 0 THEN aTriple(iStop + 1) = LEFT$(aSrc, iRemaind)

aSrc = ""
iInd = 1
DO WHILE aTriple(iInd) <> ""
   aSrc = aTriple(iInd) + "," + aSrc
   iInd = iInd + 1
LOOP

REM there's a bloody comma into the most right character :(
aFormatta = LEFT$(aSrc, LEN(aSrc) - 1)

END FUNCTION

SUB ApplyMath

END SUB

FUNCTION aSentiero (aPathDB)

aPathDB = RTRIM$(aPathDB)

REM if needed I insert final slash
IF RIGHT$(aPathDB, 1) <> "\" THEN
   aPathDB = aPathDB + "\"
END IF

aSentiero = aPathDB

END FUNCTION

SUB BasicPartDB

'CHDIR "C:\planets"

REM Engines
Stampalog "    " + aEngineDB
OPEN aEngineDB FOR BINARY ACCESS READ AS #1
FOR iInd = 1 TO 9
   GET #1, , uEngine
   TEngine(iInd).iCost = uEngine.iCost
   TEngine(iInd).iOre = uEngine.iTritanium + uEngine.iDuranium + uEngine.iMolybdenum
   TEngine(iInd).iTech = uEngine.iTechLev
NEXT iInd
CLOSE #1

REM Hulls
Stampalog "    " + aHullDB
OPEN aHullDB FOR BINARY ACCESS READ AS #1
FOR iInd = 1 TO 105
   GET #1, , uHull
   THull(iInd).iCost = uHull.iCost
   THull(iInd).iOre = uHull.iTritanium + uHull.iDuranium + uHull.iMolybdenum
   THull(iInd).iTech = uHull.iTechLev
   THull(iInd).iEngNum = uHull.iEngNumber
   THull(iInd).iMass = uHull.iHullMass
NEXT iInd
CLOSE #1

REM Beams
Stampalog "    " + aBeamDB
OPEN aBeamDB FOR BINARY ACCESS READ AS #1
FOR iInd = 1 TO 10
   GET #1, , uBeam
   TBeam(iInd).iCost = uBeam.iCost
   TBeam(iInd).iOre = uBeam.iTritanium + uBeam.iDuranium + uBeam.iMolybdenum
   TBeam(iInd).iTech = uBeam.iTechLev
NEXT iInd
CLOSE #1

REM Launcher
Stampalog "    " + aLauncherDB
OPEN aLauncherDB FOR BINARY ACCESS READ AS #1
FOR iInd = 1 TO 10
   GET #1, , uLauncher
   TLauncher(iInd).iCost = uLauncher.iCost
   TLauncher(iInd).iTorpCost = uLauncher.iTorpCost
   TLauncher(iInd).iOre = uLauncher.iTritanium + uLauncher.iDuranium + uLauncher.iMolybdenum
   TLauncher(iInd).iTech = uLauncher.iTechLev
NEXT iInd
CLOSE #1

'CHDIR "C:\QBASIC"

END SUB

SUB ComuneMsg (aMessaggio, iInd)
REM output routine for the prepared msg (aMessaggio)
REM if the file doesn't exist the "open for binary" creates it empty

aMess = aPathDB + aMsgDB
aMessPnt = aPathDB + aMsgPntDB

OPEN aMess FOR BINARY AS #1

REM lMessStart contains the first byte of the new msg
REM    (I need it for PUT and for MESSPNT file)
REM lMessEnd will be a switch too
lMessLenght = LOF(1)
lMessStart = lMessLenght + 1

REM I write the msg using lMessStart as starting byte in random PUT
PUT #1, lMessStart, aMessaggio
CLOSE #1

IF lMessLenght = 0 THEN
   REM MESS didn't exist, I delete MESSPNT (trapping error)
   ON ERROR GOTO ErrOK:
   KILL aMessPnt
   ON ERROR GOTO Generico:
END IF

OPEN aMessPnt FOR BINARY AS #1
REM if I previously deleted the file I need to skip the read
IF lMessLenght <> 0 THEN
   GET #1, , iTotMsg
END IF

REM each record is: 8byte + 2 for the first msg counter
REM I add one since I will use it to point to the first usefull byte
lMessPntStart = (iTotMsg * 8) + 2 + 1

REM rewrite the total including the new msg
iTotMsg = iTotMsg + 1
PUT #1, 1, iTotMsg

REM I jump to the first usefull byte and insert a new header record
SEEK #1, lMessPntStart
uMessPnt.iRace = iInd
uMessPnt.lOffset = lMessStart
uMessPnt.iLenght = LEN(aMessaggio)
PUT #1, , uMessPnt

CLOSE #1

END SUB

SUB ConfigMsg (aMessaggio)

DIM aWPlnBonus

aMessaggio = "<<< ItaScore Config >>>" + aCR + aCR

REM uConfig.aTorpedos = "Y" THEN lTotals(iInd) = lTotals(iInd)

IF uConfig.aFighters = "Y" THEN
   aMessaggio = aMessaggio + "Fighters: " + aComputa(uConfig.aOFgtValue) + STR$(uConfig.iFFgtValue) + aCR
ELSE aMessaggio = aMessaggio + "No Fighters" + aCR
END IF
IF uConfig.aMineFields = "Y" THEN
   aMessaggio = aMessaggio + "Mines: " + aComputa(uConfig.aOMinValue) + STR$(uConfig.iFMinValue) + aCR
ELSE aMessaggio = aMessaggio + "No Mines" + aCR
END IF
IF uConfig.aTorpedos = "Y" THEN
   aMessaggio = aMessaggio + "Torpedos: " + aComputa(uConfig.aOTpdValue) + STR$(uConfig.iFTpdValue) + aCR
ELSE aMessaggio = aMessaggio + "No Torpedos" + aCR
END IF
IF uConfig.aShips = "Y" THEN
   aMessaggio = aMessaggio + "Ships: " + aComputa(uConfig.aOShValue) + STR$(uConfig.iFShValue) + aCR
ELSE aMessaggio = aMessaggio + "No Ships" + aCR
END IF
IF uConfig.aTons = "Y" THEN
   aMessaggio = aMessaggio + "KTons: " + aComputa(uConfig.aOTonValue) + STR$(uConfig.iFTonValue) + aCR
ELSE aMessaggio = aMessaggio + "No KTons" + aCR
END IF
IF uConfig.aStarbases = "Y" THEN
   aMessaggio = aMessaggio + "Starbases (Doom bonus is: '" + uConfig.aKeepSBs + "')" + aCR
   aMessaggio = aMessaggio + "  Defences: " + aComputa(uConfig.aOSDefence) + STR$(uConfig.iFSDefence) + aCR
   aMessaggio = aMessaggio + "  TechLevels: " + aComputa(uConfig.aOSTechL) + STR$(uConfig.iFSTechL) + aCR
ELSE aMessaggio = aMessaggio + "No Starbases" + aCR
END IF

aWPlnBonus = "off"
FOR iInd = 1 TO 500
    IF uPlanetArrey(iInd).iBonus > 0 THEN
        aWPlnBonus = "IN"
        EXIT FOR
    END IF
NEXT
aMessaggio = aMessaggio + "Planets (Special Bonuses are: " + aWPlnBonus + ")" + aCR

IF uConfig.iBasePlnBonus > 0 THEN
   aMessaggio = aMessaggio + "  Base Bonus: " + STR$(uConfig.iBasePlnBonus) + aCR
ELSE aMessaggio = aMessaggio + "  No Base Bonus" + aCR
END IF
IF uConfig.aPlnResources = "Y" THEN
   aMessaggio = aMessaggio + "  Defenses: " + aComputa(uConfig.aOPDefense) + STR$(uConfig.iFPDefense) + aCR
ELSE aMessaggio = aMessaggio + "  No Defences" + aCR
END IF
IF uConfig.aPlnDefences = "Y" THEN
   aMessaggio = aMessaggio + "  Resources: " + aComputa(uConfig.aOPResources) + STR$(uConfig.iFPResources) + aCR
ELSE aMessaggio = aMessaggio + "  No Resources" + aCR
END IF

IF uConfig.aDistanceType <> "N" THEN
   aMessaggio = aMessaggio + "  Distances: " + aComputa(uConfig.aODistance) + STR$(uConfig.iFDistance) + aCR
ELSE aMessaggio = aMessaggio + "  No Distance Bonus" + aCR
END IF

SELECT CASE uConfig.aDistanceType
   CASE "H", "W"
      aMessaggio = aMessaggio + "Planet Valuation is: HomeWorld" + aCR
   CASE "A"
      aMessaggio = aMessaggio + "Planet Valuation is: Absolute" + aCR
   CASE "Z"
      aMessaggio = aMessaggio + "Planet Valuation is: Zone" + aCR
      ' aMessaggio = aMessaggio + "   Cluster centrum at" + STR$(uConfig.iXCentrum) + "," + STR$(uConfig.iYCentrum) + aCR
      aMessaggio = aMessaggio + "   4 zones are" + STR$(uConfig.iZ1Distance) + "," + STR$(uConfig.iZ2Distance) + "," + STR$(uConfig.iZ3Distance) + " and + LYs" + aCR
      aMessaggio = aMessaggio + "      for" + STR$(uConfig.iF1Distance) + "," + STR$(uConfig.iF2Distance) + "," + STR$(uConfig.iF3Distance) + " and " + STR$(uConfig.iF4Distance) + " points" + aCR
END SELECT

END SUB

FUNCTION iTurno

aNomeDB = aPathDB + aNextTurnDB
Stampalog " Reading " + aNomeDB
OPEN aNomeDB FOR BINARY ACCESS READ AS #1
GET #1, , uNextTurn
iTurno = uNextTurn.iTurn
CLOSE #1

END FUNCTION

SUB KeepSB (iLocRace, iLocID)


   IF uPlanetArrey(iLocID).iRace <> iLocRace THEN
      IF uPlanetArrey(iLocID).aBase = "Y" AND uPlanetArrey(iLocID).iTurns > uConfig.iFTurnKSBs THEN
        
         lKeepSB(iLocRace) = lKeepSB(iLocRace) + uConfig.iFKeepSBs

      ELSEIF uPlanetArrey(iLocID).aBase = "H" AND uPlanetArrey(iLocID).iTurns > uConfig.iFTurnKHWs THEN

         lKeepSB(iLocRace) = lKeepSB(iLocRace) + uConfig.iFKeepHWs

      END IF
   END IF

   IF uPlanetArrey(iLocID).iRace <> iLocRace THEN
      uPlanetArrey(iLocID).iRace = iLocRace
      uPlanetArrey(iLocID).iTurns = 0
      uPlanetArrey(iLocID).aBase = "N"
   END IF

END SUB

SUB KeepSBMsg (aMessaggio, iInd)
REM this is the specific race msg for "SBs destroyed" bonuses got

aMessaggio = "<<< ItaScore Starbases Bonus >>>" + aCR + aCR + aCR
aMessaggio = aMessaggio + ">>>  Special BONUS  <<<" + aCR + aCR

aMessaggio = aMessaggio + "This turn your score includes" + aCR + aCR

aTemp = aFormatta(lKeepSB(iInd))
aMessaggio = aMessaggio + "   " + aTemp + " points" + aCR + aCR

aMessaggio = aMessaggio + "thank to the Starbases you destroyed" + aCR


END SUB

SUB LogScore

iWidth = 28

REM PRINT #1, "<html>"
REM PRINT #1, "<body>"
REM PRINT #1, "<pre>"

FOR iInd = 1 TO 11
   IF aRaces(iInd) <> "" THEN
      aTemp = aFormatta(lTotals(iInd))
      iTemp = iWidth - LEN(aRaces(iInd)) - LEN(aTemp)
      IF iTemp <= 0 THEN iTemp = 1
      aTemp = aRaces(iInd) + SPACE$(iTemp) + aTemp + SPACE$(2) + aDecimali(sTotPerc(iInd) * 100) + "%"
      PRINT #1, aTemp
   END IF
NEXT

aTemp1 = aFormatta(lBigTotal)
aTemp = "Total Sum:" + SPACE$(iWidth - 10 - LEN(aTemp1)) + aTemp1
PRINT #1, aTemp

REM PRINT #1, "</pre>"
REM PRINT #1, "</body>"
REM PRINT #1, "</html>"

END SUB

SUB MineDB (lMines())

DO WHILE NOT EOF(1)

IF uMine.iRace > 0 THEN
   lMines(uMine.iRace) = lMines(uMine.iRace) + uMine.lUnits
END IF

GET #1, , uMine
LOOP

FOR iInd = 1 TO 11
 
   SELECT CASE uConfig.aOMinValue
      CASE IS = "*"
         lMines(iInd) = lMines(iInd) * uConfig.iFMinValue
      CASE IS = "-"
         lMines(iInd) = lMines(iInd) - uConfig.iFMinValue
      CASE IS = "+"
         lMines(iInd) = lMines(iInd) + uConfig.iFMinValue
      CASE IS = "/"
         lMines(iInd) = lMines(iInd) / uConfig.iFMinValue
      CASE IS = "%"
         lMines(iInd) = lMines(iInd) / 100 * uConfig.iFMinValue
   END SELECT

NEXT

END SUB

REM reading planets
REM file is open, first record already in the buffer
SUB PlanetDB (lResources(), lPlanets())

DO WHILE NOT EOF(1)

IF uPlanet.iRace > 0 THEN
   ' planet bonus
   IF uPlanetArrey(uPlanet.iId).iBonus > 0 THEN 'special bonus
      lPlanets(uPlanet.iRace) = lPlanets(uPlanet.iRace) + uPlanetArrey(uPlanet.iId).iBonus
      lMsgPlnBonus(uPlanet.iRace) = lMsgPlnBonus(uPlanet.iRace) + uPlanetArrey(uPlanet.iId).iBonus
   ELSE
      lPlanets(uPlanet.iRace) = lPlanets(uPlanet.iRace) + uConfig.iBasePlnBonus
   END IF
  
   ' archive resources values
   lResources(uPlanet.iRace) = lResources(uPlanet.iRace) + uPlanet.iMines + uPlanet.iFactories
   lDefences(uPlanet.iRace) = lDefences(uPlanet.iRace) + uPlanet.iDefense

   IF uConfig.aKeepSBs = "Y" THEN KeepSB uPlanet.iRace, uPlanet.iId

END IF

GET #1, , uPlanet
LOOP

FOR iInd = 1 TO 11

   SELECT CASE uConfig.aOPResources
      CASE IS = "*"
         lResources(iInd) = lResources(iInd) * uConfig.iFPResources
      CASE IS = "-"
         lResources(iInd) = lResources(iInd) - uConfig.iFPResources
      CASE IS = "+"
         lResources(iInd) = lResources(iInd) + uConfig.iFPResources
      CASE IS = "/"
         lResources(iInd) = lResources(iInd) / uConfig.iFPResources
      CASE IS = "%"
         lResources(iInd) = lResources(iInd) / 100 * uConfig.iFPResources
   END SELECT

   SELECT CASE uConfig.aOPDefense
      CASE IS = "*"
         lDefences(iInd) = lDefences(iInd) * uConfig.iFPDefense
      CASE IS = "-"
         lDefences(iInd) = lDefences(iInd) - uConfig.iFPDefense
      CASE IS = "+"
         lDefences(iInd) = lDefences(iInd) + uConfig.iFPDefense
      CASE IS = "/"
         lDefences(iInd) = lDefences(iInd) / uConfig.iFPDefense
      CASE IS = "%"
         lDefences(iInd) = lDefences(iInd) / 100 * uConfig.iFPDefense
   END SELECT

NEXT

END SUB

SUB PlnBonusMsg (aMessaggio, iInd)
REM this is the specific race msg for "not default" bonuses got

aMessaggio = "<<< ItaScore Planets Bonus >>>" + aCR + aCR + aCR
aMessaggio = aMessaggio + ">>>  Special BONUS  <<<" + aCR + aCR

aMessaggio = aMessaggio + "This turn your score includes" + aCR + aCR

aTemp = aFormatta(lMsgPlnBonus(iInd))
aMessaggio = aMessaggio + "   " + aTemp + " points" + aCR + aCR

aMessaggio = aMessaggio + "thank to some special planets you hold" + aCR


END SUB

REM Prepare the same msg and send it to all players
SUB PublicMsg (aMessaggio)

iWidth = 28
aMessaggio = "<<< ItaScore Report >>>" + aCR + aCR
aMessaggio = aMessaggio + ">>>  " + aRel + "  <<<" + aCR + aCR

FOR iInd = 1 TO 11
   IF aRaces(iInd) <> "" THEN
      aTemp = aFormatta(lTotals(iInd))
      iTemp = iWidth - LEN(aRaces(iInd)) - LEN(aTemp)
      IF iTemp <= 0 THEN iTemp = 1
      aTemp = aRaces(iInd) + SPACE$(iTemp) + aTemp + SPACE$(2) + aDecimali(sTotPerc(iInd) * 100) + "%"
      aMessaggio = aMessaggio + aTemp + aCR
   END IF
NEXT

aMessaggio = aMessaggio + STRING$(35, "-") + aCR
aTemp = aFormatta(lBigTotal)
aTemp = "Total Sum:" + SPACE$(iWidth - 10 - LEN(aTemp)) + aTemp

aMessaggio = aMessaggio + aTemp + aCR + aCR
aMessaggio = aMessaggio + "Turn number: #" + LTRIM$(STR$(iTurnNum)) + aCR

END SUB

SUB RaceMsg (aMessaggio, iInd)
REM this is the specific race msg with details

aMessaggio = "<<< ItaScore Details >>>" + aCR + aCR

iWidth = 8
aTemp = aFormatta(lShips(iInd))
aTemp = "All Ships:         " + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR
aMessaggio = aMessaggio + "Planets figures" + aCR
aTemp = aFormatta(lPlanets(iInd))
aTemp = "  Bonuses:         " + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR
aTemp = aFormatta(lResources(iInd))
aTemp = "  Mines+Facts:     " + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR
aTemp = aFormatta(lDefences(iInd))
aTemp = "  Defences:        " + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR
aTemp = aFormatta(lDistances(iInd))
aTemp = "  Distances:       " + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR
aMessaggio = aMessaggio + "Starbases figures" + aCR
aTemp = aFormatta(lSBDefences(iInd))
aTemp = "  Defences:        " + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR
aTemp = aFormatta(lSBTechL(iInd))
aTemp = "  TechLevels:      " + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR
aTemp = aFormatta(lFighters(iInd))
aTemp = "Fighters:          " + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR
aTemp = aFormatta(lMines(iInd))
aTemp = "Mine Units:        " + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR
aTemp = aFormatta(lTorpedos(iInd))
aTemp = "Torpedos (as Mkt1):" + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR
aTemp = aFormatta(lTons(iInd))
aTemp = "KiloTons:          " + SPACE$(iWidth - LEN(aTemp)) + aTemp
aMessaggio = aMessaggio + aTemp + aCR + aCR

aMessaggio = aMessaggio + "Those pictures have been delivered by" + aCR
aMessaggio = aMessaggio + "   Paolo Fiore onto Public Domain" + aCR


END SUB

SUB ShipDB (lShips(), lFighters(), lTorpedos())

DIM lWMC(11)
DIM lWOre(11)
DIM lWFighter(11)

DO WHILE NOT EOF(1)
   DO 'Ain't a real loop! I need it for the below IF
   IF uShip.iRace <= 0 OR uShip.iRace > 11 THEN EXIT DO

   lWMC(uShip.iRace) = lWMC(uShip.iRace) + (TEngine(uShip.iEngine).iCost * THull(uShip.iHull).iEngNum)
   lWOre(uShip.iRace) = lWOre(uShip.iRace) + (TEngine(uShip.iEngine).iOre * THull(uShip.iHull).iEngNum)
   lWMC(uShip.iRace) = lWMC(uShip.iRace) + THull(uShip.iHull).iCost
   IF uConfig.aShipMass = "Y" THEN
      lWOre(uShip.iRace) = lWOre(uShip.iRace) + THull(uShip.iHull).iMass
   ELSE
      lWOre(uShip.iRace) = lWOre(uShip.iRace) + THull(uShip.iHull).iOre
   END IF
   IF uShip.iBeam > 0 THEN
      lWMC(uShip.iRace) = lWMC(uShip.iRace) + (TBeam(uShip.iBeam).iCost * uShip.iNBeams)
      lWOre(uShip.iRace) = lWOre(uShip.iRace) + (TBeam(uShip.iBeam).iOre * uShip.iNBeams)
   END IF
   IF uShip.iTube > 0 THEN
      lTorpedos(uShip.iRace) = lTorpedos(uShip.iRace) + (uShip.iFightsTorps * iMineFigure(TLauncher(uShip.iTube).iTech))
      IF uConfig.aShipTBay = "Y" THEN
         lWMC(uShip.iRace) = lWMC(uShip.iRace) + (TLauncher(uShip.iTube).iCost * uShip.iNTubes)
         lWOre(uShip.iRace) = lWOre(uShip.iRace) + (TLauncher(uShip.iTube).iOre * uShip.iNTubes)
      END IF
   END IF
   IF uShip.iBays > 0 THEN
      lFighters(uShip.iRace) = lFighters(uShip.iRace) + uShip.iFightsTorps
   END IF
  
   EXIT DO
   LOOP

GET #1, , uShip
LOOP

FOR iInd = 1 TO 11

   lShips(iInd) = lWMC(iInd) + lWOre(iInd)

   SELECT CASE uConfig.aOShValue
      CASE IS = "*"
         lShips(iInd) = lShips(iInd) * uConfig.iFShValue
      CASE IS = "-"
         lShips(iInd) = lShips(iInd) - uConfig.iFShValue
      CASE IS = "+"
         lShips(iInd) = lShips(iInd) + uConfig.iFShValue
      CASE IS = "/"
         lShips(iInd) = lShips(iInd) / uConfig.iFShValue
      CASE IS = "%"
         lShips(iInd) = lShips(iInd) / 100 * uConfig.iFShValue
   END SELECT

   SELECT CASE uConfig.aOFgtValue
      CASE IS = "*"
         lFighters(iInd) = lFighters(iInd) + (lWFighter(iInd) * uConfig.iFFgtValue)
      CASE IS = "-"
         lFighters(iInd) = lFighters(iInd) + (lWFighter(iInd) - uConfig.iFFgtValue)
      CASE IS = "+"
         lFighters(iInd) = lFighters(iInd) + (lWFighter(iInd) + uConfig.iFFgtValue)
      CASE IS = "/"
         lFighters(iInd) = lFighters(iInd) + (lWFighter(iInd) / uConfig.iFFgtValue)
      CASE IS = "%"
         lFighters(iInd) = lFighters(iInd) + (lWFighter(iInd) / 100 * uConfig.iFFgtValue)

   END SELECT

   SELECT CASE uConfig.aOTpdValue
      CASE IS = "*"
         lTorpedos(iInd) = lTorpedos(iInd) * uConfig.iFTpdValue
      CASE IS = "-"
         lTorpedos(iInd) = lTorpedos(iInd) - uConfig.iFTpdValue
      CASE IS = "+"
         lTorpedos(iInd) = lTorpedos(iInd) + uConfig.iFTpdValue
      CASE IS = "/"
         lTorpedos(iInd) = lTorpedos(iInd) / uConfig.iFTpdValue
      CASE IS = "%"
         lTorpedos(iInd) = lTorpedos(iInd) / 100 * uConfig.iFTpdValue
   END SELECT

NEXT

END SUB

SUB Stampalog (aTemp)

PRINT aTemp
PRINT #9, aTemp
REM aTemp = " "

END SUB

SUB StarbaseDB (lSBDefences, lSBTechL, lFighters())

DIM lWFighter(11)

DO WHILE NOT EOF(1)
   IF uStarbase.iRace > 0 THEN
      lSBDefences(uStarbase.iRace) = lSBDefences(uStarbase.iRace) + uStarbase.iDefence
      lWFighter(uStarbase.iRace) = lWFighter(uStarbase.iRace) + uStarbase.iFighter
      lSBTechL(uStarbase.iRace) = lSBTechL(uStarbase.iRace) + uStarbase.iEngineTL
      lSBTechL(uStarbase.iRace) = lSBTechL(uStarbase.iRace) + uStarbase.iHullTL
      lSBTechL(uStarbase.iRace) = lSBTechL(uStarbase.iRace) + uStarbase.iWeaponTL
      lSBTechL(uStarbase.iRace) = lSBTechL(uStarbase.iRace) + uStarbase.iLauncherTL

      uPlanetArrey(uStarbase.iId).iRace = uStarbase.iRace
      IF uPlanetArrey(uStarbase.iId).aBase = "N" THEN uPlanetArrey(uStarbase.iId).aBase = "Y"
      uPlanetArrey(uStarbase.iId).iTurns = uPlanetArrey(uStarbase.iId).iTurns + 1

   END IF

   GET #1, , uStarbase
LOOP

FOR iInd = 1 TO 11
   SELECT CASE uConfig.aOSDefence
      CASE IS = "*"
         lSBDefences(iInd) = lSBDefences(iInd) * uConfig.iFSDefence
      CASE IS = "-"
         lSBDefences(iInd) = lSBDefences(iInd) - uConfig.iFSDefence
      CASE IS = "+"
         lSBDefences(iInd) = lSBDefences(iInd) + uConfig.iFSDefence
      CASE IS = "/"
         lSBDefences(iInd) = lSBDefences(iInd) / uConfig.iFSDefence
      CASE IS = "%"
         lSBDefences(iInd) = lSBDefences(iInd) / 100 * uConfig.iFSDefence
   END SELECT

   SELECT CASE uConfig.aOSTechL
      CASE IS = "*"
         lSBTechL(iInd) = lSBTechL(iInd) * uConfig.iFSTechL
      CASE IS = "-"
         lSBTechL(iInd) = lSBTechL(iInd) - uConfig.iFSTechL
      CASE IS = "+"
         lSBTechL(iInd) = lSBTechL(iInd) + uConfig.iFSTechL
      CASE IS = "/"
         lSBTechL(iInd) = lSBTechL(iInd) / uConfig.iFSTechL
      CASE IS = "%"
         lSBTechL(iInd) = lSBTechL(iInd) / 100 * uConfig.iFSTechL
   END SELECT
  
   SELECT CASE uConfig.aOFgtValue
      CASE IS = "*"
         lFighters(iInd) = lFighters(iInd) + (lWFighter(iInd) * uConfig.iFFgtValue)
      CASE IS = "-"
         lFighters(iInd) = lFighters(iInd) + (lWFighter(iInd) - uConfig.iFFgtValue)
      CASE IS = "+"
         lFighters(iInd) = lFighters(iInd) + (lWFighter(iInd) + uConfig.iFFgtValue)
      CASE IS = "/"
         lFighters(iInd) = lFighters(iInd) + (lWFighter(iInd) / uConfig.iFFgtValue)
      CASE IS = "%"
         lFighters(iInd) = lFighters(iInd) + (lWFighter(iInd) / 100 * uConfig.iFFgtValue)
   END SELECT

NEXT

END SUB

SUB TonDB (lTons())

FOR iInd = 1 TO 11

GET #1, , lTons(iInd)

   SELECT CASE uConfig.aOTonValue
      CASE IS = "*"
         lTons(iInd) = lTons(iInd) * uConfig.iFTonValue
      CASE IS = "-"
         lTons(iInd) = lTons(iInd) - uConfig.iFTonValue
      CASE IS = "+"
         lTons(iInd) = lTons(iInd) + uConfig.iFTonValue
      CASE IS = "/"
         lTons(iInd) = lTons(iInd) / uConfig.iFTonValue
      CASE IS = "%"
         lTons(iInd) = lTons(iInd) / 100 * uConfig.iFTonValue
   END SELECT

NEXT

END SUB

SUB XYCentrumLY (lWZ)
     
lWX = ABS(uConfig.iXCentrum - uXYPlan.iX)
lWY = ABS(uConfig.iYCentrum - uXYPlan.iY)
lWZ = SQR((lWX * lWX) + (lWY * lWY))

END SUB

SUB XYComputeZ (lWZ)

SELECT CASE lWZ
   CASE IS <= uConfig.iZ1Distance
      lDistances(uXYPlan.iRace) = lDistances(uXYPlan.iRace) + uConfig.iF1Distance
   CASE (uConfig.iZ1Distance + 1) TO uConfig.iZ2Distance
      lDistances(uXYPlan.iRace) = lDistances(uXYPlan.iRace) + uConfig.iF2Distance
   CASE (uConfig.iZ2Distance + 1) TO uConfig.iZ3Distance
      lDistances(uXYPlan.iRace) = lDistances(uXYPlan.iRace) + uConfig.iF3Distance
   CASE ELSE
      lDistances(uXYPlan.iRace) = lDistances(uXYPlan.iRace) + uConfig.iF4Distance
END SELECT

END SUB

SUB XYHWorldLY (lWZ)
REM the HW itself sets lWZ to zero

lWX = ABS(iHWPlnX(uXYPlan.iRace) - uXYPlan.iX)
lWY = ABS(iHWPlnY(uXYPlan.iRace) - uXYPlan.iY)
lWZ = SQR((lWX * lWX) + (lWY * lWY))

END SUB

REM Planets coordinates; will calculate the distance from the 'origin'
SUB XYPlanDB (lDistances())

DO WHILE NOT EOF(1)
   IF uXYPlan.iRace > 0 THEN
      SELECT CASE uConfig.aDistanceType
         CASE "A"
            XYCentrumLY lWZ
            lDistances(uXYPlan.iRace) = lDistances(uXYPlan.iRace) + lWZ
         CASE "Z"
            XYCentrumLY lWZ
            XYComputeZ lWZ
         CASE "H"
            XYHWorldLY lWZ
            lDistances(uXYPlan.iRace) = lDistances(uXYPlan.iRace) + lWZ
         CASE "W"
            XYHWorldLY lWZ
            IF lWZ > uConfig.iZ1Distance THEN lWZ = lWZ - uConfig.iZ1Distance
            lDistances(uXYPlan.iRace) = lDistances(uXYPlan.iRace) + lWZ
      END SELECT
   END IF

GET #1, , uXYPlan
LOOP

FOR iInd = 1 TO 11
   SELECT CASE uConfig.aODistance
      CASE IS = "*"
         lDistances(iInd) = lDistances(iInd) * uConfig.iFDistance
      CASE IS = "-"
         lDistances(iInd) = lDistances(iInd) - uConfig.iFDistance
      CASE IS = "+"
         lDistances(iInd) = lDistances(iInd) + uConfig.iFDistance
      CASE IS = "/"
         lDistances(iInd) = lDistances(iInd) / uConfig.iFDistance
      CASE IS = "%"
         lDistances(iInd) = lDistances(iInd) / 100 * uConfig.iFDistance
   END SELECT
NEXT

END SUB

